﻿using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Selection
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            //this.tree.Override.UseEditor = Infragistics.Win.DefaultableBoolean.True;

            this.tree.Nodes.Add("Notice that the first three characters are selected...");
            
            //  Hook the ControlAdded event
            this.tree.ControlAdded += this.tree_ControlAdded;
            this.tree.Override.LabelEdit = Infragistics.Win.DefaultableBoolean.True;
        }

        void tree_ControlAdded(object sender, ControlEventArgs e)
        {
            //  Unhook the event
            this.tree.ControlAdded -= this.tree_ControlAdded;

            //  Cache a ref to the textbox so we can clean up later,
            //  and hook the GotFocus event.
            TextBox textBox = e.Control as TextBox;
            if ( textBox != null )
            {
                this.tree.Tag = textBox;
                textBox.GotFocus += this.textBox_GotFocus;
            }
        }

        void textBox_GotFocus(object sender, EventArgs e)
        {
            TextBox textBox = sender as TextBox;
            if ( textBox != null )
            {
                int selLength = Math.Min(textBox.TextLength, 3);
                textBox.Select(0, selLength);
            }

        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                    components.Dispose();

                TextBox textBox = this.tree.Tag as TextBox;
                if ( textBox != null )
                    textBox.GotFocus -= this.textBox_GotFocus;

                this.tree.ControlAdded -= this.tree_ControlAdded;
            }

            base.Dispose(disposing);
        }


    }
}
